;//////////////////////////////////////////////////////////////////////////
;/                                                                        /
;/                                                                        /
;/                                                                        /
;/                                                                        /
;/                     DEMO TEST   FOR GAMEBOY                            /
;/                                                                        /
;/                                                                        /
;/                                                                        /
;/                                                                        /
;/                       www.powerofasm.fr.st                             /
;/                                                                        /
;//////////////////////////////////////////////////////////////////////////
 
;*** RST 00h ***
.org 0000h
 ret
    
;*** RST 08h ***
.org 0008h
 ret
    
;*** RST 10h ***
.org 0010h
 ret
    
;*** RST 18h ***
.org 0018h
 ret
    
;*** RST 20h ***
.org 0020h
 ret
    
;*** RST 28h ***
.org 0028h
 ret
    
;*** RST 30h ***
.org 0030h
 ret
    
;*** RST 38h ***
.org 0038h
 ret
    
    
;*** Hardware Interrupts ****************************************************
                                                                             
;*** Vertical blanking IRQ ***
.org 0040h
 jp vblank
 reti
     
;*** LCD status IRQ ***
.org 0048h
 jp vblank
 reti
     
;*** Timer owerflow IRQ ***
.org 0050h
 jp vblank
 reti
     
;*** Serial transfer completion IRQ ***
.org 0058h
 reti
     
;*** GamePad IRQ ***
.org 0060h
 jp GamePad

 reti


;////////////////////////////////////////////////////////////////////////////
.org 0101h
 jp Start
           
    .db 0CEh,0EDh,66h,66h,0CCh,0Dh,00h,0Bh,03h,73h,00h,83h,00h,0Ch,00h,0Dh
    .db 00,08,11h,1Fh,88h,89h,00,0Eh,0DCh,0CCh,6Eh,0E6h,0DDh,0DDh,0D9h,099h
    .db 0BBh,0BBh,67h,63h,6Eh,0Eh,0ECh,0CCh,0DDh,0DCh,99h,9Fh,0BBh,0B9h,33h,3Eh
                                                               
    .db "HxC2001 GB      " ; GamePak name (16 characters)
    .db 00h,00h,00h        ; (Not used?)
    .db 00h                ; ROM Only
    .db 00h                ; ROM Size 32k
    .db 00h                ; RAM Size  0k
    .dw 0C0DEh              ; Manufacturer code
                           ; C0DE = MegaMan_X
    .db 03h                ; Version
    .db 00
    .db 00,00
                                    
;*** Begin ******************************************************************

 .org 150h
Start:
      di
      ld a,00010001b
      ld (0ffffh),a


      ld sp,0fff4h

      ld a,01h
      ld (0ff0fh),a

      ld a,00000000b
      ld (0ff00h+26h),a ;plus de son
      ld (0ff00h+42h),a ;scroll y bg
      ld (0ff00h+43h),a ;scroll x bg
      ld (0ff00h+4Ah),a ;scroll y win
      ld (0ff00h+4Bh),a ;scroll x win


      ld a,11100100b
      ld (0ff00h+47h),a ;palette
      ld (0ff00h+48h),a ;palette obj 1
      ld (0ff00h+49h),a ;palette obj 2

      ld a,01011001b

      ld (0ff00h+40h),a ;lcd control

      ld a,00000000b
      ld (0ff00h+00h),a ;game pad


    call CopieTile
    call MapBg

      ld a,11011001b

      ld (0ff00h+40h),a ;lcd control

      ld hl,8000h
      ld a,1
      ld (0ff81h),a
      ld (0ff82h),a


    ei

ddrghd:
 halt
 jp ddrghd


vblank:
 push hl
  push af
  ld hl,0ff43h
  ld a,(0FF81h)
  add a,(hl)
  ld (hl),a

  ld hl,0ff42h
  ld a,(0FF82h)
  add a,(hl)
  ld (hl),a

;  ld a,0
 ; ld (0FF82h),a
  ;ld (0FF81h),a
  pop af
 pop hl
 reti

GamePad:
 push af
    di
      ld a,00100000b
      ld (0ff00h+00h),a ;game pad
      ld (0ff00h+00h),a ;game pad
      ld (0ff00h+00h),a ;game pad
      ld (0ff00h+00h),a ;game pad

      ld a,(0ff00h+00h)
      ld a,(0ff00h+00h) 
      ld a,(0ff00h+00h) 
      ld a,(0ff00h+00h) 

      ld b,a
      and 00000001b
      cp 0
      jr nz,suitekey1
       ld hl,0ff81h

      dec  (hl)
suitekey1:
      ld a,b
      and 00000010b
      cp 0
      jr nz,suitekey2

       ld hl,0ff81h
      inc  (hl)
      
suitekey2:
      ld a,b
       and 00000100b
      cp 0
      jr nz,suitekey3
      ld hl,0ff82h
      inc  (hl)

suitekey3:
      ld a,b
      and 00001000b
      cp 0
      jr nz,suitekey4
       ld hl,0ff82h
      dec  (hl)

suitekey4:
      ld a,00000000b
      ld (0ff00h+00h),a ;game pad
      ld (0ff00h+00h),a ;game pad
      ld (0ff00h+00h),a ;game pad
      ld (0ff00h+00h),a ;game pad
      ld (0ff00h+00h),a ;game pad


      ld a,00010000b
      ld (0ff00h+00h),a ;game pad
      ld (0ff00h+00h),a ;game pad
      ld (0ff00h+00h),a ;game pad
      ld (0ff00h+00h),a ;game pad
      ld (0ff00h+00h),a ;game pad
      ld (0ff00h+00h),a ;game pad

      ld a,(0ff00h+00h)
      ld a,(0ff00h+00h) 
      ld a,(0ff00h+00h) 
      ld a,(0ff00h+00h) 
      ld a,(0ff00h+00h) 
      ld b,a
      and 00000001b
      cp 0
      jr nz,suitekey1b
      ld a,11100100b
      ld (0ff00h+47h),a ;palette
suitekey1b:
      ld a,b
      and 00000010b
      cp 0
      jr nz,suitekey2b
      ld a,00011011b
      ld (0ff00h+47h),a ;palette
suitekey2b:
      ld a,00000000b
      ld (0ff00h+00h),a ;game pad
     ld a,(0ff0fh)
     res 4,a
     ld (0ff0fh),a

     ei
  pop af
 reti

CopieTile:
 Push hl
 ld hl,T.DAT_TileData
 ld bc,8000h
bouclew:
 ld a,(hl)
 ld (bc),a

 inc bc
 inc hl
 ld a,b
 cp 90h
 jr nz,bouclew
 pop hl
 ret

MapBg:
 Push hl
 ld hl,TM.DAT_TileMap
 ld bc,9c00h
bouclewb:
 ld a,(hl)
 ld (bc),a

 inc bc
 inc hl
 ld a,b
 cp 0a0h
 jr nz,bouclewb
 pop hl
 ret



T.DAT_TileData:
  ; E:\gb\asm\Mmxfont.bin 4096 bytes
 
  .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
  .db 126,126,129,129,165,165,129,129,189,189,153,153,129,129,126,126
  .db 126,126,255,255,219,219,255,255,195,195,231,231,255,255,126,126
  .db 108,108,254,254,254,254,254,254,124,124,56,56,16,16,0,0
  .db 16,16,56,56,124,124,254,254,124,124,56,56,16,16,0,0
  .db 16,16,56,56,56,56,214,214,254,254,214,214,16,16,124,124
  .db 16,16,56,56,124,124,254,254,254,254,214,214,16,16,124,124
  .db 0,0,0,0,60,24,60,60,60,60,60,24,0,0,0,0
  .db 255,255,255,255,195,231,195,195,195,195,195,231,255,255,255,255
  .db 0,0,24,60,36,102,66,66,66,66,36,102,24,60,0,0
  .db 255,255,129,195,189,153,189,189,189,189,189,153,129,195,255,255
  .db 15,15,7,7,15,15,125,125,204,204,204,204,204,204,120,120
  .db 60,60,102,102,102,102,102,102,60,60,24,24,126,126,24,24
  .db 63,63,51,51,63,63,48,48,48,48,112,112,240,240,224,224
  .db 127,127,99,99,127,127,99,99,99,99,103,103,230,230,192,192
  .db 153,153,90,90,60,60,231,231,231,231,60,60,90,90,153,153
  .db 192,128,240,224,252,248,255,254,252,248,240,224,192,128,0,0
  .db 3,1,15,7,63,31,255,127,63,31,15,7,3,1,0,0
  .db 24,24,60,60,126,126,24,24,24,24,126,126,60,60,24,24
  .db 102,102,102,102,102,102,102,102,102,102,0,0,102,102,0,0
  .db 255,127,219,219,219,219,251,123,27,27,27,27,27,27,0,0
  .db 126,60,102,102,124,56,108,108,108,108,124,56,204,204,252,120
  .db 0,0,0,0,0,0,0,0,126,126,126,126,126,126,0,0
  .db 24,24,60,60,126,126,24,24,126,126,60,60,24,24,255,255
  .db 16,16,56,56,124,124,16,16,16,16,16,16,16,16,0,0
  .db 16,16,16,16,16,16,16,16,124,124,56,56,16,16,0,0
  .db 0,0,8,8,12,12,254,254,12,12,8,8,0,0,0,0
  .db 0,0,32,32,96,96,254,254,96,96,32,32,0,0,0,0
  .db 0,0,0,0,192,192,192,192,192,192,254,254,0,0,0,0
  .db 0,0,36,36,102,102,255,255,102,102,36,36,0,0,0,0
  .db 0,0,24,24,60,60,126,126,255,255,255,255,0,0,0,0
  .db 0,0,255,255,255,255,126,126,60,60,24,24,0,0,0,0
  .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
  .db 60,24,60,60,60,60,24,60,60,24,0,0,24,24,0,0
  .db 102,102,102,102,102,102,0,0,0,0,0,0,0,0,0,0
  .db 108,108,108,108,254,254,108,108,254,254,108,108,108,108,0,0
  .db 24,24,126,62,96,96,126,60,6,6,126,124,24,24,0,0
  .db 0,0,0,0,102,102,108,108,24,24,54,54,102,102,0,0
  .db 56,56,108,108,56,56,118,118,220,220,204,204,118,118,0,0
  .db 24,24,24,24,56,48,0,0,0,0,0,0,0,0,0,0
  .db 12,12,24,24,48,48,48,48,48,48,24,24,12,12,0,0
  .db 48,48,24,24,12,12,12,12,12,12,24,24,48,48,0,0
  .db 0,0,102,102,60,60,255,255,60,60,102,102,0,0,0,0
  .db 0,0,24,24,24,24,126,126,24,24,24,24,0,0,0,0
  .db 0,0,0,0,0,0,0,0,0,0,24,24,24,24,56,48
  .db 0,0,0,0,0,0,126,126,0,0,0,0,0,0,0,0
  .db 0,0,0,0,0,0,0,0,0,0,24,24,24,24,0,0
  .db 3,1,7,2,14,4,28,8,56,16,112,32,224,64,192,128
  .db 126,60,102,102,110,110,126,126,118,118,102,102,126,60,0,0
  .db 24,24,56,56,24,24,24,24,24,24,24,24,60,60,0,0
  .db 126,60,102,102,6,6,126,60,96,96,96,96,126,126,0,0
  .db 126,60,102,102,6,6,30,28,6,6,102,102,126,60,0,0
  .db 102,102,102,102,102,102,126,62,6,6,6,6,6,6,0,0
  .db 126,126,96,96,96,96,126,124,6,6,102,102,126,60,0,0
  .db 126,60,102,102,96,96,126,124,102,102,102,102,126,60,0,0
  .db 126,126,102,102,6,6,12,12,24,24,24,24,24,24,0,0
  .db 126,60,102,102,102,102,126,60,102,102,102,102,126,60,0,0
  .db 126,60,102,102,102,102,126,62,6,6,102,102,126,60,0,0
  .db 0,0,24,24,24,24,0,0,24,24,24,24,0,0,0,0
  .db 0,0,24,24,24,24,0,0,24,24,24,24,56,48,0,0
  .db 12,12,24,24,48,48,96,96,48,48,24,24,12,12,0,0
  .db 0,0,0,0,126,126,0,0,126,126,0,0,0,0,0,0
  .db 96,96,48,48,24,24,12,12,24,24,48,48,96,96,0,0
  .db 126,60,102,102,6,6,12,12,24,24,0,0,24,24,0,0
  .db 254,124,198,198,222,222,222,222,222,220,192,192,252,124,0,0
  .db 126,60,102,102,102,102,126,126,102,102,102,102,102,102,0,0
  .db 126,124,102,102,102,102,126,124,102,102,102,102,126,124,0,0
  .db 126,60,102,102,96,96,96,96,96,96,102,102,126,60,0,0
  .db 126,124,102,102,102,102,102,102,102,102,102,102,126,124,0,0
  .db 126,126,96,96,96,96,120,120,96,96,96,96,126,126,0,0
  .db 126,126,96,96,96,96,120,120,96,96,96,96,96,96,0,0
  .db 126,60,102,102,96,96,110,110,102,102,102,102,126,60,0,0
  .db 102,102,102,102,102,102,126,126,102,102,102,102,102,102,0,0
  .db 60,60,24,24,24,24,24,24,24,24,24,24,60,60,0,0
  .db 6,6,6,6,6,6,6,6,102,102,102,102,126,60,0,0
  .db 102,102,102,102,108,108,120,120,108,108,102,102,102,102,0,0
  .db 96,96,96,96,96,96,96,96,96,96,96,96,126,126,0,0
  .db 254,252,214,214,214,214,214,214,198,198,198,198,198,198,0,0
  .db 102,102,118,118,126,126,110,110,102,102,102,102,102,102,0,0
  .db 126,60,102,102,102,102,102,102,102,102,102,102,126,60,0,0
  .db 126,124,102,102,102,102,126,124,96,96,96,96,96,96,0,0
  .db 126,60,102,102,102,102,102,102,110,106,102,100,126,58,0,0
  .db 126,124,102,102,102,102,126,124,120,120,108,108,102,102,0,0
  .db 126,60,102,102,96,96,126,60,6,6,102,102,126,60,0,0
  .db 126,126,24,24,24,24,24,24,24,24,24,24,24,24,0,0
  .db 102,102,102,102,102,102,102,102,102,102,102,102,126,60,0,0
  .db 102,102,102,102,102,102,102,102,102,102,60,60,24,24,0,0
  .db 198,198,198,198,198,198,214,214,214,214,214,214,254,252,0,0
  .db 198,198,198,198,108,108,56,56,108,108,198,198,198,198,0,0
  .db 102,102,102,102,102,102,60,60,24,24,24,24,24,24,0,0
  .db 126,126,6,6,12,12,24,24,48,48,96,96,126,126,0,0
  .db 60,60,48,48,48,48,48,48,48,48,48,48,60,60,0,0
  .db 192,128,224,64,112,32,56,16,28,8,14,4,7,2,3,1
  .db 60,60,12,12,12,12,12,12,12,12,12,12,60,60,0,0
  .db 16,16,56,56,108,108,198,198,0,0,0,0,0,0,0,0
  .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,254
  .db 48,48,48,48,56,24,0,0,0,0,0,0,0,0,0,0
  .db 0,0,0,0,62,60,6,6,126,62,102,102,126,62,0,0
  .db 96,96,96,96,96,96,126,124,102,102,102,102,126,124,0,0
  .db 0,0,0,0,126,60,102,102,96,96,102,102,126,60,0,0
  .db 6,6,6,6,6,6,126,62,102,102,102,102,126,62,0,0
  .db 0,0,0,0,126,60,102,102,126,126,96,96,124,60,0,0
  .db 62,28,54,54,48,48,120,120,48,48,48,48,48,48,0,0
  .db 0,0,0,0,126,62,102,102,102,102,126,62,6,6,126,124
  .db 96,96,96,96,126,124,102,102,102,102,102,102,102,102,0,0
  .db 24,24,0,0,24,24,24,24,24,24,24,24,24,24,0,0
  .db 6,6,0,0,6,6,6,6,6,6,102,102,102,102,126,60
  .db 96,96,96,96,102,102,108,108,120,120,108,108,102,102,0,0
  .db 56,56,24,24,24,24,24,24,24,24,24,24,24,24,0,0
  .db 0,0,0,0,254,252,214,214,214,214,198,198,198,198,0,0
  .db 0,0,0,0,126,124,102,102,102,102,102,102,102,102,0,0
  .db 0,0,0,0,126,60,102,102,102,102,102,102,126,60,0,0
  .db 0,0,0,0,126,124,102,102,102,102,126,124,96,96,96,96
  .db 0,0,0,0,126,62,102,102,102,102,126,62,6,6,6,6
  .db 0,0,0,0,126,124,102,102,96,96,96,96,96,96,0,0
  .db 0,0,0,0,126,62,96,96,126,60,6,6,126,124,0,0
  .db 24,24,126,126,24,24,24,24,24,24,24,24,24,24,0,0
  .db 0,0,0,0,102,102,102,102,102,102,102,102,126,62,0,0
  .db 0,0,0,0,102,102,102,102,102,102,60,60,24,24,0,0
  .db 0,0,0,0,198,198,214,214,214,214,254,254,108,108,0,0
  .db 0,0,0,0,198,198,108,108,56,56,108,108,198,198,0,0
  .db 0,0,0,0,102,102,102,102,102,102,126,62,6,6,126,124
  .db 0,0,0,0,126,126,12,12,24,24,48,48,126,126,0,0
  .db 14,14,24,24,24,24,112,112,24,24,24,24,14,14,0,0
  .db 24,24,24,24,24,24,0,0,24,24,24,24,24,24,0,0
  .db 112,112,24,24,24,24,14,14,24,24,24,24,112,112,0,0
  .db 118,118,220,220,0,0,0,0,0,0,0,0,0,0,0,0
  .db 0,0,16,16,56,56,108,108,198,198,198,198,254,254,0,0
  .db 124,0,198,0,192,0,198,0,124,0,12,0,6,0,124,0
  .db 0,0,204,0,0,0,204,0,204,0,204,0,118,0,0,0
  .db 28,0,0,0,120,0,204,0,252,0,192,0,120,0,0,0
  .db 126,0,129,0,60,0,6,0,62,0,102,0,59,0,0,0
  .db 204,0,0,0,120,0,12,0,124,0,204,0,118,0,0,0
  .db 224,0,0,0,120,0,12,0,124,0,204,0,118,0,0,0
  .db 48,0,48,0,120,0,12,0,124,0,204,0,118,0,0,0
  .db 0,0,0,0,124,0,198,0,192,0,120,0,12,0,56,0
  .db 126,0,129,0,60,0,102,0,126,0,96,0,60,0,0,0
  .db 204,0,0,0,120,0,204,0,252,0,192,0,120,0,0,0
  .db 224,0,0,0,120,0,204,0,252,0,192,0,120,0,0,0
  .db 204,0,0,0,112,0,48,0,48,0,48,0,120,0,0,0
  .db 124,0,130,0,56,0,24,0,24,0,24,0,60,0,0,0
  .db 224,0,0,0,112,0,48,0,48,0,48,0,120,0,0,0
 .db 198,0,16,0,124,0,198,0,254,0,198,0,198,0,0,0
 .db 48,0,48,0,0,0,120,0,204,0,252,0,204,0,0,0
 .db 28,0,0,0,252,0,96,0,120,0,96,0,252,0,0,0
 .db 0,0,0,0,127,0,12,0,127,0,204,0,127,0,0,0
 .db 62,0,108,0,204,0,254,0,204,0,204,0,206,0,0,0
 .db 120,0,132,0,0,0,120,0,204,0,204,0,120,0,0,0
 .db 0,0,204,0,0,0,120,0,204,0,204,0,120,0,0,0
 .db 0,0,224,0,0,0,120,0,204,0,204,0,120,0,0,0
 .db 120,0,132,0,0,0,204,0,204,0,204,0,118,0,0,0
 .db 0,0,224,0,0,0,204,0,204,0,204,0,118,0,0,0
 .db 0,0,204,0,0,0,204,0,204,0,124,0,12,0,248,0
 .db 195,0,24,0,60,0,102,0,102,0,60,0,24,0,0,0
 .db 204,0,0,0,204,0,204,0,204,0,204,0,120,0,0,0
 .db 24,0,24,0,126,0,192,0,192,0,126,0,24,0,24,0
 .db 56,0,108,0,100,0,240,0,96,0,230,0,252,0,0,0
 .db 204,0,204,0,120,0,48,0,252,0,48,0,252,0,48,0
 .db 248,0,204,0,204,0,250,0,198,0,207,0,198,0,195,0
 .db 14,0,27,0,24,0,60,0,24,0,24,0,216,0,112,0
 .db 28,0,0,0,120,0,12,0,124,0,204,0,118,0,0,0
 .db 56,0,0,0,112,0,48,0,48,0,48,0,120,0,0,0
 .db 0,0,28,0,0,0,120,0,204,0,204,0,120,0,0,0
 .db 0,0,28,0,0,0,204,0,204,0,204,0,118,0,0,0
 .db 0,0,248,0,0,0,184,0,204,0,204,0,204,0,0,0
 .db 252,0,0,0,204,0,236,0,252,0,220,0,204,0,0,0
 .db 60,0,108,0,108,0,62,0,0,0,126,0,0,0,0,0
 .db 56,0,108,0,108,0,56,0,0,0,124,0,0,0,0,0
 .db 24,0,0,0,24,0,24,0,48,0,102,0,60,0,0,0
 .db 0,0,0,0,0,0,252,0,192,0,192,0,0,0,0,0
 .db 0,0,0,0,0,0,252,0,12,0,12,0,0,0,0,0
 .db 198,0,204,0,216,0,54,0,107,0,194,0,132,0,15,0
 .db 195,0,198,0,204,0,219,0,55,0,109,0,207,0,3,0
 .db 24,0,0,0,24,0,24,0,60,0,60,0,24,0,0,0
 .db 0,0,51,0,102,0,204,0,102,0,51,0,0,0,0,0
 .db 0,0,204,0,102,0,51,0,102,0,204,0,0,0,0,0
 .db 34,34,136,136,34,34,136,136,34,34,136,136,34,34,136,136
 .db 85,85,170,170,85,85,170,170,85,85,170,170,85,85,170,170
 .db 221,221,119,119,221,221,119,119,221,221,119,119,221,221,119,119
 .db 24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24
 .db 24,24,24,24,24,24,248,248,24,24,24,24,24,24,24,24
 .db 24,24,24,24,248,248,24,24,248,248,24,24,24,24,24,24
 .db 54,54,54,54,54,54,246,246,54,54,54,54,54,54,54,54
 .db 0,0,0,0,0,0,254,252,54,54,54,54,54,54,54,54
 .db 0,0,0,0,248,240,24,24,248,248,24,24,24,24,24,24
 .db 54,54,54,54,246,246,6,6,246,246,54,54,54,54,54,54
 .db 54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54
 .db 0,0,0,0,254,254,6,6,246,246,54,54,54,54,54,54
 .db 54,54,54,54,246,246,6,6,254,254,0,0,0,0,0,0
 .db 54,54,54,54,54,54,54,54,254,252,0,0,0,0,0,0
 .db 24,24,24,24,248,248,24,24,248,240,0,0,0,0,0,0
 .db 0,0,0,0,0,0,0,0,248,240,24,24,24,24,24,24
 .db 24,24,24,24,24,24,24,24,31,15,0,0,0,0,0,0
 .db 24,24,24,24,24,24,24,24,255,255,0,0,0,0,0,0
 .db 0,0,0,0,0,0,0,0,255,255,24,24,24,24,24,24
 .db 24,24,24,24,24,24,24,24,31,31,24,24,24,24,24,24
 .db 0,0,0,0,0,0,0,0,255,255,0,0,0,0,0,0
 .db 24,24,24,24,24,24,24,24,255,255,24,24,24,24,24,24
 .db 24,24,24,24,31,31,24,24,31,31,24,24,24,24,24,24
 .db 54,54,54,54,54,54,54,54,55,55,54,54,54,54,54,54
 .db 54,54,54,54,55,55,48,48,63,63,0,0,0,0,0,0
 .db 0,0,0,0,63,63,48,48,55,55,54,54,54,54,54,54
 .db 54,54,54,54,247,247,0,0,255,255,0,0,0,0,0,0
 .db 0,0,0,0,255,255,0,0,247,247,54,54,54,54,54,54
 .db 54,54,54,54,55,55,48,48,55,55,54,54,54,54,54,54
 .db 0,0,0,0,255,255,0,0,255,255,0,0,0,0,0,0
 .db 54,54,54,54,247,247,0,0,247,247,54,54,54,54,54,54
 .db 24,24,24,24,255,255,0,0,255,255,0,0,0,0,0,0
 .db 54,54,54,54,54,54,54,54,255,255,0,0,0,0,0,0
 .db 0,0,0,0,255,255,0,0,255,255,24,24,24,24,24,24
 .db 0,0,0,0,0,0,0,0,255,255,54,54,54,54,54,54
 .db 54,54,54,54,54,54,54,54,63,31,0,0,0,0,0,0
 .db 24,24,24,24,31,31,24,24,31,15,0,0,0,0,0,0
 .db 0,0,0,0,31,15,24,24,31,31,24,24,24,24,24,24
 .db 0,0,0,0,0,0,0,0,63,31,54,54,54,54,54,54
 .db 54,54,54,54,54,54,54,54,255,255,54,54,54,54,54,54
 .db 24,24,24,24,255,255,24,24,255,255,24,24,24,24,24,24
 .db 24,24,24,24,24,24,24,24,248,240,0,0,0,0,0,0
 .db 0,0,0,0,0,0,0,0,31,15,24,24,24,24,24,24
 .db 255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255
 .db 0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255
 .db 240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240
 .db 15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15
 .db 255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0
 .db 0,0,0,0,118,118,220,220,216,216,220,220,118,118,0,0
 .db 0,0,252,120,204,204,252,248,204,204,204,204,220,216,192,192
 .db 0,0,126,126,102,102,96,96,96,96,96,96,96,96,0,0
 .db 0,0,0,0,254,254,108,108,108,108,108,108,108,108,0,0
 .db 126,126,102,102,48,48,24,24,48,48,102,102,126,126,0,0
 .db 0,0,0,0,254,126,216,216,216,216,216,216,248,112,0,0
 .db 0,0,102,102,102,102,102,102,102,102,124,124,96,96,192,192
 .db 0,0,118,118,220,220,24,24,24,24,24,24,24,24,0,0
 .db 252,252,48,48,120,120,204,204,204,204,120,120,48,48,252,252
 .db 56,56,108,108,198,198,254,254,198,198,108,108,56,56,0,0
 .db 56,56,108,108,198,198,198,198,108,108,108,108,238,238,0,0
 .db 28,28,48,48,24,24,124,124,204,204,204,204,120,120,0,0
 .db 0,0,0,0,126,126,219,219,219,219,126,126,0,0,0,0
 .db 6,6,12,12,126,126,219,219,219,219,126,126,96,96,192,192
 .db 56,56,96,96,192,192,248,248,192,192,96,96,56,56,0,0
 .db 252,120,204,204,204,204,204,204,204,204,204,204,204,204,0,0
 .db 0,0,126,126,0,0,126,126,0,0,126,126,0,0,0,0
 .db 24,24,24,24,126,126,24,24,24,24,0,0,126,126,0,0
 .db 48,48,24,24,12,12,24,24,48,48,0,0,126,126,0,0
 .db 12,12,24,24,48,48,24,24,12,12,0,0,126,126,0,0
 .db 31,14,27,27,27,27,24,24,24,24,24,24,24,24,24,24
 .db 24,24,24,24,24,24,24,24,24,24,216,216,216,216,248,112
 .db 24,24,24,24,0,0,126,126,0,0,24,24,24,24,0,0
 .db 0,0,118,118,220,220,0,0,118,118,220,220,0,0,0,0
 .db 124,56,108,108,108,108,124,56,0,0,0,0,0,0,0,0
 .db 0,0,0,0,0,0,24,24,24,24,0,0,0,0,0,0
 .db 0,0,0,0,0,0,0,0,24,24,0,0,0,0,0,0
 .db 15,15,12,12,12,12,12,12,204,204,108,108,60,60,28,28
 .db 248,176,216,216,216,216,216,216,0,0,0,0,0,0,0,0
 .db 112,112,152,152,48,48,96,96,248,248,0,0,0,0,0,0
 .db 0,0,0,0,60,60,60,60,60,60,60,60,0,0,0,0
 .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

 

TM.DAT_TileMap:



.db "(C) HxC 2001    (C) HxC 2001   "
.db " "
.db "                               "
.db " "

.db " (C) HxC 2001    (C) HxC 2001  "
.db " "
.db "                               "
.db " "

.db "  (C) HxC 2001    (C) HxC 2001 "
.db " "
.db "                               "
.db " "

.db "   (C) HxC 2001    (C) HxC 2001"
.db " "
.db "                               "
.db " "

.db "    (C) HxC 2001    (C) HxC 200"
.db "1"
.db "                               "
.db " "

.db "www.powerofasm.fr.st           "
.db " "
.db "                               "
.db " "

.db "    www.obsolete-tears.fr.st   "
.db " "
.db "                               "
.db " "

.db "  CODE : Jeff                  "
.db " "
.db "                               "
.db " "
.db "    (C) HxC 2001    (C) HxC 200"
.db "1"
.db " "
.db "                               "
.db "(C) HxC 2001    (C) HxC 2001   "
.db " "
.db " "
.db "                               "

.db " (C) HxC 2001    (C) HxC 2001  "
.db " "
.db " "
.db "                               "

.db "  (C) HxC 2001    (C) HxC 2001 "
.db " "
.db " "
.db "                               "

.db "   (C) HxC 2001    (C) HxC 2001"
.db " "
.db " "
.db "                               "

.db "    (C) HxC 2001    (C) HxC 200"
.db "1"
.db " "
.db "                               "

.db "(C) HxC 2001    (C) HxC 2001   "
.db " "
.db " "
.db "                               "

.db " (C) HxC 2001    (C) HxC 2001  "
.db " "
.db " "
.db "                               "

.db "  (C) HxC 2001    (C) HxC 2001 "
.db " "
.db " "
.db "                               "

.db "   (C) HxC 2001    (C) HxC 2001"
.db " "
.db " "
.db "                               "

.db "    (C) HxC 2001    (C) HxC 200"
.db "1"
.db "(C) HxC 2001    (C) HxC 2001   "
.db " "
.db " "
.db "                               "

.db " (C) HxC 2001    (C) HxC 2001  "
.db " "
.db " "
.db "                               "

.db "  (C) HxC 2001    (C) HxC 2001 "
.db " "
.db " "
.db "                               "

.db "   (C) HxC 2001    (C) HxC 2001"
.db " "
.db " "
.db "                               "

.db "    (C) HxC 2001    (C) HxC 200"
.db "1"
.db " "
.db "                               "

.db "(C) HxC 2001    (C) HxC 2001   "
.db " "
.db " "
.db "                               "

.db " (C) HxC 2001    (C) HxC 2001  "
.db " "
.db " "
.db "                               "

.db "  (C) HxC 2001    (C) HxC 2001 "
.db " "
.db " "
.db "                               "

.db "   (C) HxC 2001    (C) HxC 2001"
.db " "
.db "                               "

.db " "
.db "    (C) HxC 2001    (C) HxC 200"
.db "1"


.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00



 .org 08000h
 .end
